routes/web.php
<?php

use App\Http\Controllers\admin\CommonController;
use App\Http\Controllers\Admin\MarkController;
use App\Http\Controllers\Admin\StudentController;
use App\Http\Controllers\Admin\SubjectController;
use App\Http\Controllers\Admin\TeacherController;
use App\Http\Controllers\Admin\TermController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::prefix('admin')->group(function () {
    Route::group(['middleware' => 'auth:web'], function () {
        Route::resource('teacher', TeacherController::class);
        Route::get('delete/{route}/{id}', [CommonController::class, 'delete'])->name('delete');
        Route::resource('student', StudentController::class);
        Route::resource('subject', SubjectController::class);
        Route::resource('term', TermController::class);
        Route::resource('mark', MarkController::class);
    });
});

app/Models/Student.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Student extends Model
{
    use HasFactory;
}

app/Http/Controllers/Admin/StudentController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Student;
use App\Models\Teacher;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Yajra\DataTables\Facades\DataTables;

class StudentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request->ajax()) {
            $data = Student::select('students.id', 'students.name', 'age', 'gender', 'teachers.name as teacher')->leftjoin('teachers', 'teachers.id', 'students.teacher_id')->orderBy('id', 'desc');
            return DataTables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $button = '<button type="button" data-href="' . route('student.edit', $row->id) . '" class="btn btn-xs btn-primary edit_button" data-container=".modal_class"><i class="fa fa-edit"></i></button>&nbsp';
                    $button .= '<button data-href="' . route('delete', ['student', $row->id]) . '" class="btn btn-xs btn-danger btn-modal"><i class="fa fa-trash"></i></button>';
                    return $button;
                })
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('search'))) {
                        $instance->where(function ($w) use ($request) {
                            $search = $request->get('search');
                            $w->Where('name', 'LIKE', "%$search%");
                        });
                    }
                })
                ->rawColumns(['action'])
                ->make(true);
        }
        return view('admin.students.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $teachers = Teacher::get();
        return view('admin.students.create')->with(compact('teachers'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if ($request->ajax()) {
            $rules = [
                'name'     => 'required|unique:students',
                'age'     => 'required|numeric',
                'gender'     => 'required',
                'teacher_id'     => 'required',
            ];
            $messages = [
                'name.required' => 'Name Required',
            ];
            $validator = Validator::make(request()->all(), $rules, $messages);
            if ($validator->fails()) {
                return response()->json(['status' => false, 'message' => $validator->errors()->first()]);
            }
            try {
                $student = new Student();
                $student->name      = $request->name;
                $student->age      = $request->age;
                $student->gender      = $request->gender;
                $student->teacher_id      = $request->teacher_id;
                $student->save();
                return response()->json(['status' => true, 'message' => 'Successfully created']);
            } catch (\Exception $e) {
                return response()->json(['status' => false, 'message' => "Something went Wrong!!"]);
            }
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $student = student::where('id', $id)->first();
        $teachers = Teacher::get();
        return view('admin.students.edit')->with(compact('student', 'teachers'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if (request()->ajax()) {
            $rules = [
                'name'     => 'required|unique:students,name,' . $id,
                'age'     => 'required',
                'gender'     => 'required',
                'teacher_id'     => 'required',
            ];
            $messages = [
                'name.required' => 'Name Required',
            ];
            $validator = Validator::make(request()->all(), $rules, $messages);
            if ($validator->fails()) {
                return response()->json(['status' => false, 'message' => $validator->errors()->first()]);
            }
            try {
                $student = student::findOrFail($id);
                $student->name      = $request->name;
                $student->age      = $request->age;
                $student->gender      = $request->gender;
                $student->teacher_id      = $request->teacher_id;
                $student->save();
                return response()->json(['status' => true, 'message' => 'Successfully updated']);
            } catch (\Exception $e) {
                return response()->json(['status' => false, 'message' => 'Something went Wrong!']);
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if (request()->ajax()) {
            try {
                $student = Student::findOrFail($id);
                $student->delete();
                return response()->json(['status' => true, 'message' => 'Successfully deleted']);
            } catch (\Exception $e) {
                return response()->json(['status' => false, 'message' => 'Something went Wrong!']);
            }
        }
    }
}

resources/views/admin/students/create.blade.php
<div class="modal-dialog" role="document">
    <div class="modal-content">
        <form method="post" action="{{route('student.store')}}" accept-charset="UTF-8" id="createForm">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">ADD STUDENT</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label for="name" class="control-label">NAME:*</label>
                    <input class="form-control" required="" placeholder="NAME" autocomplete="off" name="name" type="text"  maxlength="50">
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">AGE:*</label>
                    <input class="form-control" required="" placeholder="AGE" autocomplete="off" name="age" type="text"  maxlength="10">
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">GENDER:*</label>
                    <select class="form-control" required="" name="gender">
                        <option value="">SELECT</option>
                        <option value="Male">Male</option>
                        <option value="Female">Female</option>
                        <option value="Other">Other</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">REPORTING TEACHER:*</label>
                    <select class="form-control" required="" name="teacher_id">
                        <option value="">SELECT</option>
                        @foreach ($teachers as $item)
                            <option value="{{$item->id}}">{{$item->name}}</option>
                        @endforeach
                    </select>
                </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-success save_button">SAVE</button>
                <button type="button" class="btn btn-warning" data-dismiss="modal">CLOSE</button>
            </div>
        </form>
  </div><!-- /.modal-content -->
</div><!-- /.modal-dialog -->

resources/views/admin/students/edit.blade.php
 <div class="modal-dialog" role="document">
    <div class="modal-content">
        <form method="post" action="{{route('student.update',$student->id)}}" accept-charset="UTF-8" id="edit_form">
            <input name="_method" type="hidden" value="PUT">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">EDIT STUDENT</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label for="name" class="control-label">NAME:*</label>
                    <input class="form-control" value="{{$student->name}}" required="" placeholder="NAME" autocomplete="off" name="name" type="text"  maxlength="50">
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">AGE:*</label>
                    <input class="form-control" required="" value="{{$student->age}}" placeholder="AGE" autocomplete="off" name="age" type="text"  maxlength="10">
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">GENDER:*</label>
                    <select class="form-control" required="" name="gender">
                        <option value="">SELECT</option>
                        <option value="Male" @if ($student->gender=='Male') selected @endif>Male</option>
                        <option value="Female" @if ($student->gender=='Female') selected @endif>Female</option>
                        <option value="Other" @if ($student->gender=='Other') selected @endif>Other</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="name" class="control-label">REPORTING TEACHER:*</label>
                    <select class="form-control" required="" name="teacher_id">
                        <option value="">SELECT</option>
                        @foreach ($teachers as $item)
                            <option value="{{$item->id}}" @if ($student->teacher_id==$item->id) selected @endif>{{$item->name}}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-success save_button">UPDATE</button>
                <button type="button" class="btn btn-warning" data-dismiss="modal">CLOSE</button>
            </div>
        </form>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->

resources/views/admin/students/index.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
              <button type="button" class="btn btn-primary btn-modal" data-href="{{route('student.create')}}" data-container=".modal_class">
                <i class="fa fa-plus-circle"></i> ADD STUDENT</button>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">HOME</a></li>
                <li class="breadcrumb-item active">STUDENTS</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">STUDENTS LIST</h3>
                </div>
                <div class="card-body">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="data-table table table-bordered table-striped mg-b-0">
                                    <thead>
                                      <tr>
                                        <th>#</th>
                                        <th>NAME</th>
                                        <th>AGE</th>
                                        <th>GENDER</th>
                                        <th>REPORTING TEACHER</th>
                                        <th>ACTION</th>
                                      </tr>
                                    </thead>
                                    <tbody></tbody>
                                </table>
                            </div>
                        </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
<div class="modal fade modal_class" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel"></div>
@include('admin.layouts.footer')
<script >
    $(document).ready(function() {
        var table = $('.data-table').DataTable({
        processing: true,
        serverSide: true,
        dom: "<'row'<'col-sm-2'l><'col-sm-7 text-center'B><'col-sm-3'f>><'row'<'col-sm-12'tr>><'row'<'col-sm-6'i><'col-sm-6'p>>",
        buttons: ["copy", "csv", "excel", "pdf", "print", "colvis"],
        ajax: {
          url: "{{ route('student.index') }}",
          data: function (d) {
                d.search = $('input[type="search"]').val();
            }
        },
        columns: [
            {data: 'id', 'orderable': false, 'searchable': false },
            {data: 'name', name: 'name'},
            {data: 'age', name: 'age'},
            {data: 'gender', name: 'gender'},
            {data: 'teacher', name: 'teacher'},
            {data: 'action', name: 'action'},
        ],
      });


      /*CREATE MODAL POST AJAX CALL */
      $(document).unbind('submit').on('submit', 'form#createForm', function(e){
            e.preventDefault();
            $(this).find('button[type="submit"]').attr('disabled', true);
            var data = $(this).serialize();
            $.ajax({
                method: "post",
                url: $(this).attr("action"),
                dataType: "json",
                data: data,
                success:function(result){
                    if(result.status == true){
                        $('div.modal_class').modal('hide');
                        toastr.success(result.message);
                        $('.data-table').DataTable().ajax.reload();
                    }else{
                        toastr.error(result.message);
                        $('.save_button').attr('disabled', false);
                    }
                }
            });
        });
        
        /*EDIT MODAL POST AJAX CALL */
        $(document).on('click', 'button.edit_button', function() {
            $('div.modal_class').load($(this).data('href'), function() {
                $(this).modal('show');
                $('form#edit_form').submit(function(e) {
                    $(this).find('button[type="submit"]').attr('disabled', true);
                    e.preventDefault();
                    var data = $(this).serialize();

                    $.ajax({
                        method: 'POST',
                        url: $(this).attr('action'),
                        dataType: 'json',
                        data: data,
                        success: function(result) {
                            if (result.status === true) {
                                $('div.modal_class').modal('hide');
                                toastr.success(result.message);
                                $('.data-table').DataTable().ajax.reload();
                            } else {
                                toastr.error(result.message);
                            $('.save_button').attr('disabled', false);
                            }
                        },
                    });
                });
            });
        });
    });
   </script>
   @include('admin.layouts.scripts')